package by.zerg.psim.gui;

import java.awt.BorderLayout;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.io.File;
import java.util.ArrayList;
import java.util.List;

import javax.imageio.ImageIO;
import javax.swing.JPanel;

import org.apache.log4j.Logger;

import by.zerg.psim.model.Config;

public class ImagePanel extends JPanel implements MainFrameListener {
	private static final Logger LOG = Logger.getLogger(ImagePanel.class);
	BufferedImage buffer;
	JPanel centralPanel;

	List<ImagePanelListener> listeners;

	public ImagePanel() {
		listeners = new ArrayList<ImagePanelListener>();

		centralPanel = new JPanel(new BorderLayout()) {

			@Override
			public void paintComponent(Graphics g) {
				super.paintComponent(g);
				if (buffer != null) {
					switch (Config.getInstance().getImageSizing()) {
					case Config.ORIGINAL_IMAGE_SIZING:
						g.drawImage(buffer, getWidth() / 2 - buffer.getWidth()
								/ 2, getHeight() / 2 - buffer.getHeight() / 2,
								buffer.getWidth(), buffer.getHeight(), null);
						break;

					case Config.SCALED_IMAGE_SIZING:
						int imageWidth = getWidth();
						int imageHeigth = (int) ((double) imageWidth
								* buffer.getHeight() / buffer.getWidth());
						if (imageHeigth > getHeight()) {
							imageHeigth = getHeight();
							imageWidth = imageHeigth * buffer.getWidth()
									/ buffer.getHeight();
						}
						g.drawImage(buffer, getWidth() / 2 - imageWidth / 2,
								getHeight() / 2 - imageHeigth / 2, imageWidth,
								imageHeigth, null);
						break;
					}
				} else {
					g.clearRect(0, 0, getWidth(), getHeight());
				}
			}

		};
		// centralPanel.setPreferredSize(new Dimension(300, 200));

		setLayout(new BorderLayout());
		add(centralPanel);
	}

	public void addListener(ImagePanelListener listener) {
		listeners.add(listener);
	}

	public void setImage(BufferedImage image) {
		try {
			// if (image == null) {
			// buffer = ImageIO.read(new File("images\\file_not_found.png"));
			// } else {
			// buffer = image;
			// }
			buffer = image;
			repaint();
		} catch (Throwable t) {
			LOG.error("can't set image: " + image);
		}
	}

	@Override
	public void imageSizingChanged() {
		repaint();
	}

	@Override
	public void refreshButtonClicked() {
		// TODO Auto-generated method stub

	}

	@Override
	public void convert2bmpButtonClicked() {
		// TODO Auto-generated method stub

	}

	@Override
	public void convert2pngButtonClicked() {
		// TODO Auto-generated method stub

	}

	@Override
	public void extractMaskButtonClicked() {
		// TODO Auto-generated method stub

	}

	@Override
	public void openButtonClicked() {
		// TODO Auto-generated method stub
		
	}
}
