package by.zerg.psim.gui;

import static by.zerg.psim.helpers.Constants.TITLE;

import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Graphics;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.ArrayList;
import java.util.List;

import javax.swing.Box;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.border.TitledBorder;

import by.zerg.psim.model.Config;

public class MainFrame extends JFrame {
	JButton openButton;
	JButton refreshButton;
	JButton convert2bmpButton;
	JButton convert2pngButton;
	JButton extractMaskButton;
	// JButton openMainImageButton;
	// JButton findMainImageButton;
	// JButton editMainImageButton;
	// JButton refreshMainImageButton;
	// JButton openMaskImageButton;
	// JButton findMaskImageButton;
	// JButton editMaskImageButton;
	// JButton refreshMaskImageButton;
	MainImagePanel mainImagePanel;
	MaskImagePanel maskImagePanel;
	ResultImagePanel resultImagePanel;
	JRadioButton originalSizeRadioButton;
	JRadioButton scaledSizeRadioButton;
	JCheckBox autoOpenAssociatedImagesCheckbox;
	JCheckBox autoOpenExportsCheckbox;
	JCheckBox autoBackupTargetsCheckbox;
	JCheckBox saveCurrentConfigOnExitCheckbox;

	List<MainFrameListener> listeners;

	public MainFrame() {
		listeners = new ArrayList<MainFrameListener>();

		openButton = new JButton("Open");
		openButton.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				for (MainFrameListener listener : listeners) {
					listener.openButtonClicked();
				}
			}

		});

		refreshButton = new JButton("Refresh");
		refreshButton.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				for (MainFrameListener listener : listeners) {
					listener.refreshButtonClicked();
				}
			}

		});

		// openMainImageButton = new JButton("Open");
		// openMainImageButton.addActionListener(new ActionListener() {
		//
		// @Override
		// public void actionPerformed(ActionEvent e) {
		// for (MainFrameListener listener : listeners) {
		// listener.openMainImageButtonClicked();
		// }
		// }
		//
		// });
		//
		// findMainImageButton = new JButton("Find");
		// findMainImageButton.addActionListener(new ActionListener() {
		//
		// @Override
		// public void actionPerformed(ActionEvent e) {
		// for (MainFrameListener listener : listeners) {
		// listener.findMainImageButtonClicked();
		// }
		// }
		//
		// });
		//
		// editMainImageButton = new JButton("Edit");
		// editMainImageButton.addActionListener(new ActionListener() {
		//
		// @Override
		// public void actionPerformed(ActionEvent e) {
		// for (MainFrameListener listener : listeners) {
		// listener.editMainImageButtonClicked();
		// }
		// }
		//
		// });
		//
		// refreshMainImageButton = new JButton("Refresh");
		// refreshMainImageButton.addActionListener(new ActionListener() {
		//
		// @Override
		// public void actionPerformed(ActionEvent e) {
		// for (MainFrameListener listener : listeners) {
		// listener.refreshMainImageButtonClicked();
		// }
		// }
		//
		// });
		//
		// openMaskImageButton = new JButton("Open");
		// openMaskImageButton.addActionListener(new ActionListener() {
		//
		// @Override
		// public void actionPerformed(ActionEvent e) {
		// for (MainFrameListener listener : listeners) {
		// listener.openMaskImageButtonClicked();
		// }
		// }
		//
		// });
		//
		// findMaskImageButton = new JButton("Find");
		// findMaskImageButton.addActionListener(new ActionListener() {
		//
		// @Override
		// public void actionPerformed(ActionEvent e) {
		// for (MainFrameListener listener : listeners) {
		// listener.findMaskImageButtonClicked();
		// }
		// }
		//
		// });
		//
		// editMaskImageButton = new JButton("Edit");
		// editMaskImageButton.addActionListener(new ActionListener() {
		//
		// @Override
		// public void actionPerformed(ActionEvent e) {
		// for (MainFrameListener listener : listeners) {
		// listener.editMaskImageButtonClicked();
		// }
		// }
		//
		// });
		//
		// refreshMaskImageButton = new JButton("Refresh");
		// refreshMaskImageButton.addActionListener(new ActionListener() {
		//
		// @Override
		// public void actionPerformed(ActionEvent e) {
		// for (MainFrameListener listener : listeners) {
		// listener.refreshMaskImageButtonClicked();
		// }
		// }
		//
		// });

		mainImagePanel = new MainImagePanel();
		listeners.add(mainImagePanel);
		maskImagePanel = new MaskImagePanel();
		listeners.add(maskImagePanel);
		resultImagePanel = new ResultImagePanel();
		listeners.add(resultImagePanel);

		originalSizeRadioButton = new JRadioButton("Original");
		originalSizeRadioButton.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				Config config = Config.getInstance();
				if (config.getImageSizing() == Config.SCALED_IMAGE_SIZING) {
					System.out.println("original size chosen");
					Config.getInstance().setImageSizing(
							Config.ORIGINAL_IMAGE_SIZING);
					for (MainFrameListener listener : listeners) {
						listener.imageSizingChanged();
					}
				}
			}

		});

		scaledSizeRadioButton = new JRadioButton("Scaled");
		scaledSizeRadioButton.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				Config config = Config.getInstance();
				if (config.getImageSizing() == Config.ORIGINAL_IMAGE_SIZING) {
					System.out.println("scaled size chosen");
					Config.getInstance().setImageSizing(
							Config.SCALED_IMAGE_SIZING);
					for (MainFrameListener listener : listeners) {
						listener.imageSizingChanged();
					}
				}
			}

		});
		ButtonGroup radioGroup = new ButtonGroup();
		radioGroup.add(originalSizeRadioButton);
		radioGroup.add(scaledSizeRadioButton);
		switch (Config.getInstance().getImageSizing()) {
		case Config.ORIGINAL_IMAGE_SIZING:
			originalSizeRadioButton.setSelected(true);
			break;
		case Config.SCALED_IMAGE_SIZING:
			scaledSizeRadioButton.setSelected(true);
			break;
		}

		convert2bmpButton = new JButton("PNG -> BMP");
		convert2bmpButton.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				for (MainFrameListener listener : listeners) {
					listener.convert2bmpButtonClicked();
				}
			}

		});

		convert2pngButton = new JButton("BMP -> PNG");
		convert2pngButton.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				for (MainFrameListener listener : listeners) {
					listener.convert2pngButtonClicked();
				}
			}

		});

		extractMaskButton = new JButton("Extract mask");
		extractMaskButton.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				for (MainFrameListener listener : listeners) {
					listener.extractMaskButtonClicked();
				}
			}

		});

		autoOpenAssociatedImagesCheckbox = new JCheckBox(
				"Auto-open Associated Images");
		autoOpenAssociatedImagesCheckbox.setSelected(Config.getInstance()
				.isAutoOpenAssociatedImages());
		autoOpenAssociatedImagesCheckbox
				.addActionListener(new ActionListener() {

					@Override
					public void actionPerformed(ActionEvent e) {
						Config.getInstance().setAutoOpenAssociatedImages(
								autoOpenAssociatedImagesCheckbox.isSelected());
					}

				});

		autoOpenExportsCheckbox = new JCheckBox("Auto-open Exports");
		autoOpenExportsCheckbox.setSelected(Config.getInstance()
				.isAutoOpenExports());
		autoOpenExportsCheckbox.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				Config.getInstance().setAutoOpenExports(
						autoOpenExportsCheckbox.isSelected());
			}

		});

		autoBackupTargetsCheckbox = new JCheckBox("Auto-backup Target Images");
		autoBackupTargetsCheckbox.setSelected(Config.getInstance()
				.isAutoBackupTargets());
		autoBackupTargetsCheckbox.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				Config.getInstance().setAutoBackupTargets(
						autoBackupTargetsCheckbox.isSelected());
			}

		});

		saveCurrentConfigOnExitCheckbox = new JCheckBox(
				"Save Current Config on Exit");
		saveCurrentConfigOnExitCheckbox.setSelected(Config.getInstance()
				.isSaveCurrentConfigOnExit());
		saveCurrentConfigOnExitCheckbox.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				Config.getInstance().setSaveCurrentConfigOnExit(
						saveCurrentConfigOnExitCheckbox.isSelected());
			}

		});

		addWindowListener(new WindowAdapter() {

			@Override
			public void windowClosing(WindowEvent e) {
				Config config = Config.getInstance();
				if (!config.isSaveCurrentConfigOnExit()) {
					int result = Messenger.getInstance().showOnCloseDialog(
							MainFrame.this);
					switch (result) {
					case Messenger.ALWAYS_YES:
						config.setSaveCurrentConfigOnExit(true);
						config.save();
						break;
					case Messenger.YES:
						config.save();
						break;
					case Messenger.ABORT:
						return;
					}
				} else {
					config.save();
				}
				System.exit(1);
			}

		});
		getRootPane().setGlassPane(new JComponent() {

			@Override
			public void paintComponent(Graphics g) {
				g.setColor(new Color(0, 0, 0, 100));
				g.fillRect(0, 0, getWidth(), getHeight());
				super.paintComponent(g);
			}

		});
	}

	public void init() {
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		setTitle(TITLE);
		setLayout(new GridBagLayout());

		// JPanel mainImagePanelContainer = new JPanel(new BorderLayout());
		// mainImagePanelContainer.setBorder(new TitledBorder("Main Image"));
		// mainImagePanelContainer.add(mainImagePanel);
		// JPanel mainImageControlsPanel = new JPanel();
		// mainImageControlsPanel.add(openMainImageButton);
		// mainImageControlsPanel.add(findMainImageButton);
		// mainImageControlsPanel.add(editMainImageButton);
		// mainImageControlsPanel.add(refreshMainImageButton);
		// mainImagePanelContainer.add(mainImageControlsPanel,
		// BorderLayout.SOUTH);
		//
		// JPanel resultImagePanelContainer = new JPanel(new BorderLayout());
		// resultImagePanelContainer.setBorder(new
		// TitledBorder("Result Image"));
		// resultImagePanelContainer.setMinimumSize(new Dimension(200, 200));
		// resultImagePanelContainer.setPreferredSize(new Dimension(200, 200));
		// resultImagePanelContainer.add(resultImagePanel);
		//
		// JPanel maskImagePanelContainer = new JPanel(new BorderLayout());
		// maskImagePanelContainer.setBorder(new TitledBorder("Mask Image"));
		// maskImagePanelContainer.add(maskImagePanel);
		// JPanel maskImageControlsPanel = new JPanel();
		// maskImageControlsPanel.add(openMaskImageButton);
		// maskImageControlsPanel.add(findMaskImageButton);
		// maskImageControlsPanel.add(editMaskImageButton);
		// maskImageControlsPanel.add(refreshMaskImageButton);
		// maskImagePanelContainer.add(maskImageControlsPanel,
		// BorderLayout.SOUTH);

		JPanel topPanel = new JPanel(new GridLayout(1, 3));
		// topPanel.add(mainImagePanelContainer);
		// topPanel.add(resultImagePanelContainer);
		// topPanel.add(maskImagePanelContainer);
		topPanel.add(mainImagePanel);
		topPanel.add(resultImagePanel);
		topPanel.add(maskImagePanel);
		GridBagConstraints c = new GridBagConstraints();
		c.gridx = c.gridy = 0;
		c.gridwidth = 1;
		c.weightx = c.weighty = 1;
		c.fill = GridBagConstraints.BOTH;
		add(topPanel, c);

		JPanel inputPanel = new JPanel();
		inputPanel.setBorder(new TitledBorder("Input Actions"));
		inputPanel.add(refreshButton);

		JPanel outputPanel = new JPanel();
		outputPanel.setBorder(new TitledBorder("Output Actions"));
		outputPanel.add(convert2bmpButton);
		outputPanel.add(convert2pngButton);
		outputPanel.add(extractMaskButton);

		JPanel centralPanel = new JPanel(new GridLayout(1, 2));
		centralPanel.add(inputPanel);
		centralPanel.add(outputPanel);
		c.gridy++;
		c.weighty = 0;
		add(centralPanel, c);

		JPanel sizePanel = new JPanel();
		sizePanel.setBorder(new TitledBorder("Image Sizing"));
		sizePanel.add(originalSizeRadioButton);
		sizePanel.add(scaledSizeRadioButton);

		JPanel optionsPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
		optionsPanel.setBorder(new TitledBorder("Options"));
		Box optionsBox = Box.createVerticalBox();
		optionsBox.add(autoOpenAssociatedImagesCheckbox);
		optionsBox.add(autoOpenExportsCheckbox);
		optionsBox.add(autoBackupTargetsCheckbox);
		optionsBox.add(saveCurrentConfigOnExitCheckbox);
		optionsPanel.add(optionsBox);

		JPanel bottomPanel = new JPanel(new GridBagLayout());
		c.gridx = c.gridy = 0;
		c.weightx = 0;
		bottomPanel.add(sizePanel, c);
		c.gridx++;
		c.weightx = 1;
		c.fill = GridBagConstraints.HORIZONTAL;
		bottomPanel.add(optionsPanel, c);
		c.gridx = 0;
		c.gridy = 2;
		add(bottomPanel, c);

		pack();
		setMinimumSize(getSize());
		setSize(getWidth(), getHeight() + resultImagePanel.getWidth()
				- resultImagePanel.getHeight());
		setLocationRelativeTo(null);
		mainImagePanel.buttonsPanel.setVisible(false);
		maskImagePanel.buttonsPanel.setVisible(false);
		setVisible(true);
	}

	public void addListener(MainFrameListener listener) {
		listeners.add(listener);
	}

	public MainImagePanel getMainImagePanel() {
		return mainImagePanel;
	}

	public MaskImagePanel getMaskImagePanel() {
		return maskImagePanel;
	}

	public ImagePanel getResultImagePanel() {
		return resultImagePanel;
	}
}
