package by.zerg.psim.gui;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;

public class MainImagePanel extends ImagePanel {
	JPanel buttonsPanel;
	JButton openButton;
	JButton findButton;
	JButton editButton;
	JButton refreshButton;

	public MainImagePanel() {
		super();

		setBorder(new TitledBorder("Main Image"));

		MouseAdapter mouseAdapter = new MouseAdapter() {

			@Override
			public void mouseEntered(MouseEvent e) {
				buttonsPanel.setVisible(true);
			}

			@Override
			public void mouseExited(MouseEvent e) {
				buttonsPanel.setVisible(false);
			}

		};

		buttonsPanel = new JPanel();
		// buttonsPanel.setVisible(false);
		buttonsPanel.addMouseListener(mouseAdapter);

		openButton = new JButton("Open");
		openButton.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				doOpen();
			}

		});
		openButton.addMouseListener(mouseAdapter);

		findButton = new JButton("Find");
		findButton.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				doFind();
			}

		});
		findButton.addMouseListener(mouseAdapter);

		editButton = new JButton("Edit");
		editButton.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				doEdit();
			}

		});
		editButton.addMouseListener(mouseAdapter);

		refreshButton = new JButton("Refresh");
		refreshButton.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				doRefresh();
			}

		});
		refreshButton.addMouseListener(mouseAdapter);

		buttonsPanel.setOpaque(false);
		buttonsPanel.add(openButton);
		buttonsPanel.add(findButton);
		buttonsPanel.add(editButton);
		buttonsPanel.add(refreshButton);
		centralPanel.add(buttonsPanel, BorderLayout.SOUTH);
		centralPanel.addMouseListener(mouseAdapter);

		addMouseListener(mouseAdapter);
	}

	protected void doOpen() {
		for (ImagePanelListener listener : listeners) {
			listener.openMainImageButtonClicked();
		}
	}

	protected void doFind() {
		for (ImagePanelListener listener : listeners) {
			listener.findMainImageButtonClicked();
		}
	}

	protected void doEdit() {
		for (ImagePanelListener listener : listeners) {
			listener.editMainImageButtonClicked();
		}
	}

	protected void doRefresh() {
		for (ImagePanelListener listener : listeners) {
			listener.refreshMainImageButtonClicked();
		}
	}
}
