package by.zerg.psim.gui;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

public class Messenger {
	public static final int ABORT = JOptionPane.CLOSED_OPTION;
	public static final int ALWAYS_YES = JOptionPane.YES_OPTION;
	public static final int YES = JOptionPane.NO_OPTION;
	public static final int NO = JOptionPane.CANCEL_OPTION;
	private static final Object[] CLOSE_OPTIONS = { "Always Yes", "Yes", "No" };
	private static final Object[] TYPE_OPTIONS = { "Try Again",
			"Select Another One", "Cancel" };
	private static final Object[] SIZE_OPTIONS1 = { "Try Again",
			"Resize Selected", "Resize Mask", "Cancel" };

	private static Messenger instance;

	private Messenger() {

	}

	public static Messenger getInstance() {
		if (instance == null) {
			instance = new Messenger();
		}
		return instance;
	}

	public void showMessageDialog(JFrame parent, String message) {
		parent.getRootPane().getGlassPane().setVisible(true);
		JOptionPane.showMessageDialog(parent, message);
		parent.getRootPane().getGlassPane().setVisible(false);
	}

	public int showOnCloseDialog(JFrame parent) {
		parent.getRootPane().getGlassPane().setVisible(true);
		int result = JOptionPane.showOptionDialog(parent,
				"Would you like to save current Config?",
				"Save Config on Exit", JOptionPane.YES_NO_CANCEL_OPTION,
				JOptionPane.QUESTION_MESSAGE, null, CLOSE_OPTIONS,
				CLOSE_OPTIONS[0]);
		parent.getRootPane().getGlassPane().setVisible(false);
		return result;
	}

	public int showOnWrongImageTypeDialog(JFrame parent) {
		parent.getRootPane().getGlassPane().setVisible(true);
		int result = JOptionPane.showOptionDialog(parent,
				"Can't read selected Image...", "Error",
				JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.ERROR_MESSAGE,
				null, TYPE_OPTIONS, TYPE_OPTIONS[0]);
		parent.getRootPane().getGlassPane().setVisible(false);
		return result;
	}

	public int showOnWrongImageSizeDialog(JFrame parent) {
		parent.getRootPane().getGlassPane().setVisible(true);
		int result = JOptionPane.showOptionDialog(parent,
				"Would you like to save current Config?",
				"Save Config on Exit", JOptionPane.YES_NO_CANCEL_OPTION,
				JOptionPane.QUESTION_MESSAGE, null, SIZE_OPTIONS1,
				SIZE_OPTIONS1[0]);
		parent.getRootPane().getGlassPane().setVisible(false);
		return result;
	}
}
