package by.zerg.psim.helpers;

import java.io.BufferedReader;
import java.io.InputStreamReader;

import org.apache.log4j.Logger;

public class BinExecutor {
	private static final Logger LOG = Logger.getLogger(BinExecutor.class);

	public static final int SUCCESS = 0;
	public static final int FAILURE = 1;

	public static int execute(String cmd) {
		if (LOG.isDebugEnabled()) {
			LOG.debug("start of executing command[ " + cmd + " ]");
		}
		int exitValue = FAILURE;
		try {
			Process p = Runtime.getRuntime().exec(cmd);
			BufferedReader processOutput = new BufferedReader(
					new InputStreamReader(p.getInputStream()));
			BufferedReader processError = new BufferedReader(
					new InputStreamReader(p.getErrorStream()));
			while (processOutput.readLine() != null
					|| processError.readLine() != null)
				;
			processOutput.close();
			processError.close();
			exitValue = p.waitFor();
		} catch (Throwable t) {
			LOG.error("unhandled exception while executing command[ " + cmd
					+ " ]", t);
			exitValue = FAILURE;
		}
		if (LOG.isDebugEnabled()) {
			LOG.debug("result of executing command[ " + cmd + " ] is "
					+ exitValue);
		}
		return exitValue;
	}
}
